/**
 * Segment Public API
 * The Segment Public API helps you manage your Segment Workspaces and its resources. You can use the API to perform CRUD (create, read, update, delete) operations at no extra charge. This includes working with resources such as Sources, Destinations, Warehouses, Tracking Plans, and the Segment Destinations and Sources Catalogs.  All CRUD endpoints in the API follow REST conventions and use standard HTTP methods. Different URL endpoints represent different resources in a Workspace.  See the next sections for more information on how to use the Segment Public API.
 *
 * The version of the OpenAPI document: 58.8.0
 * Contact: friends@segment.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from './models';
import { AudienceDefinitionWithoutType } from './audienceDefinitionWithoutType';
import { AudiencePreviewResult } from './audiencePreviewResult';
import { AudienceSize } from './audienceSize';
import { ReadAudiencePreviewOptions } from './readAudiencePreviewOptions';

/**
 * An audience preview.
 */
export class AudiencePreview {
    /**
     * Unique identifier for tracking and retrieving results of an audience preview.
     */
    'id': string;
    /**
     * The audience type of the preview.
     */
    'audienceType': AudiencePreview.AudienceTypeEnum;
    'definition': AudienceDefinitionWithoutType;
    'options': ReadAudiencePreviewOptions;
    /**
     * Status for the audience preview.
     */
    'status': AudiencePreview.StatusEnum;
    /**
     * Sampled result membership for the audience preview. Only has a value if the status is \'COMPLETED\'.
     */
    'results'?: Array<AudiencePreviewResult>;
    'size'?: AudienceSize;
    /**
     * Explanation of why the audience preview failed. Only has a value if status is \'FAILED\'.
     */
    'failureReason'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }> = [
        {
            name: 'id',
            baseName: 'id',
            type: 'string',
        },
        {
            name: 'audienceType',
            baseName: 'audienceType',
            type: 'AudiencePreview.AudienceTypeEnum',
        },
        {
            name: 'definition',
            baseName: 'definition',
            type: 'AudienceDefinitionWithoutType',
        },
        {
            name: 'options',
            baseName: 'options',
            type: 'ReadAudiencePreviewOptions',
        },
        {
            name: 'status',
            baseName: 'status',
            type: 'AudiencePreview.StatusEnum',
        },
        {
            name: 'results',
            baseName: 'results',
            type: 'Array<AudiencePreviewResult>',
        },
        {
            name: 'size',
            baseName: 'size',
            type: 'AudienceSize',
        },
        {
            name: 'failureReason',
            baseName: 'failureReason',
            type: 'string',
        },
    ];

    static getAttributeTypeMap() {
        return AudiencePreview.attributeTypeMap;
    }
}

export namespace AudiencePreview {
    export enum AudienceTypeEnum {
        ACCOUNTS = <any>'ACCOUNTS',
        USERS = <any>'USERS',
    }
    export enum StatusEnum {
        COMPLETED = <any>'COMPLETED',
        FAILED = <any>'FAILED',
        RUNNING = <any>'RUNNING',
    }
}
