/**
 * Segment Public API
 * The Segment Public API helps you manage your Segment Workspaces and its resources. You can use the API to perform CRUD (create, read, update, delete) operations at no extra charge. This includes working with resources such as Sources, Destinations, Warehouses, Tracking Plans, and the Segment Destinations and Sources Catalogs.  All CRUD endpoints in the API follow REST conventions and use standard HTTP methods. Different URL endpoints represent different resources in a Workspace.  See the next sections for more information on how to use the Segment Public API.
 *
 * The version of the OpenAPI document: 58.8.0
 * Contact: friends@segment.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from './models';
import { PeriodicConfig } from './periodicConfig';
import { SpecificDaysConfig } from './specificDaysConfig';

/**
 * Configuration for PERIODIC or SPECIFIC_DAYS strategies.
 */
export class Config {
    /**
     * Go duration format string, only supporting units \"day\" (days), \"h\" (hours) and \"m\" (minutes).
     */
    'interval': string;
    /**
     * Days of week for schedule (0=Sunday, 6=Saturday).
     */
    'days': Array<number>;
    /**
     * Hours of day for schedule (0-23).
     */
    'hours': Array<number>;
    /**
     * TZ database time zone identifier; for example, America/New_York.
     */
    'timezone': string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }> = [
        {
            name: 'interval',
            baseName: 'interval',
            type: 'string',
        },
        {
            name: 'days',
            baseName: 'days',
            type: 'Array<number>',
        },
        {
            name: 'hours',
            baseName: 'hours',
            type: 'Array<number>',
        },
        {
            name: 'timezone',
            baseName: 'timezone',
            type: 'string',
        },
    ];

    static getAttributeTypeMap() {
        return Config.attributeTypeMap;
    }
}
